DECLARE FUNCTION fromhex! (inhey$)
'Cruft-O-Matic(tm) 6502 disassembler
'Written by Kevin Horton in around '95 or so
'This program will disassemble the input file into the output file
'Note the program will end with an error.  This is OK :-)
CLS
'Input filename:
ON ERROR GOTO handler

DIM stupid$(255)

FOR a = 0 TO 15
stupid$(a) = "0" + HEX$(a)
NEXT
FOR a = 16 TO 255
stupid$(a) = HEX$(a)
NEXT

PRINT "Cruft-o-Matic 2000(tm) 6502 Disassembler"
PRINT "NOTE: precede number by D for decimal entry (Hex otherwise)"
INPUT "Filename, Please"; filename$
INPUT "Offset INTO file to start disassembly at"; offs$
INPUT "Address for disassembly to start at"; saddr$

INPUT "output filename"; outfil$

IF LEN(offs$) = 0 THEN offs$ = "0"
IF LEN(saddr$) = 0 THEN saddr$ = "0"

IF (LEFT$(offs$, 1) = "d") OR (LEFT$(offs$, 1) = "D") THEN
 offs = VAL(RIGHT$(offs$, LEN(offs$) - 1))
 ELSE
 offs = fromhex(offs$)
 END IF

IF (LEFT$(saddr$, 1) = "d") OR (LEFT$(saddr$, 1) = "D") THEN
 saddr = VAL(RIGHT$(saddr$, LEN(saddr$) - 1))
 ELSE
 saddr = fromhex(saddr$)
 END IF
 LOCATE 10, 1
 PRINT "Working..."


'PRINT HEX$(saddr)
'PRINT HEX$(offs)

'END


'Output filenam:
'outfil$ = "test2.txt"
'a800
'Starting program counter:
pc = saddr

'un-comment the following if you need from 08000-0ffffh
'pc = pc + 32768
'Offset into the file
w = offs   '16'((32768 + &H2) - (0))
'w = 65536 * 2 + 16 + 49152
'w = (65536 * 8 + 16) - 16384
'PRINT HEX$(pc); "ss"
OPEN outfil$ FOR OUTPUT AS 2
'OPEN "scrn:" FOR OUTPUT AS 2
OPEN filename$ FOR BINARY AS 1
SEEK #1, w + 1
'pc = &H1800

DIM instruct$(255), mode(255): FOR a = 0 TO 31: FOR b = 0 TO 7
READ instruct$(a + b * 32), mode(a + b * 32): NEXT: NEXT
'PRINT LOC(1)
mainloop:
'pc = pc AND 65535
'FOR q = 0 TO 1000: NEXT
'IF LOC(1) > 65535 THEN END
opcode = ASC(INPUT$(1, 1))
mnemonic$ = instruct$(opcode): addmode = mode(opcode)
peecee$ = HEX$(pc)
WHILE LEN(peecee$) < 4: peecee$ = "0" + peecee$: WEND
PRINT #2, USING "\   \: "; peecee$; : PRINT #2, USING "\\ "; stupid$(opcode);
pc = pc + 1 + addmode:
IF addmode = 1 OR addmode = 2 THEN code1 = ASC(INPUT$(1, 1))
IF addmode = 2 THEN code2 = ASC(INPUT$(1, 1))
'code2 = code2 AND &H1F:
IF addmode = 0 THEN PRINT #2, "      ";
IF addmode = 1 OR addmode = 2 THEN PRINT #2, USING "\\ "; stupid$(code1);
IF addmode = 2 THEN PRINT #2, USING "\\ "; stupid$(code2);
IF addmode = 1 THEN PRINT #2, "   ";
FOR a = 1 TO LEN(mnemonic$): a$ = MID$(mnemonic$, a, 1)
IF a$ <> "*" AND a$ <> "&" THEN PRINT #2, a$;
IF a$ = "*" THEN GOSUB doabs
IF a$ = "&" THEN GOSUB dorel
NEXT: PRINT #2, "": GOTO mainloop

doabs: PRINT #2, "$"; : IF addmode = 1 THEN PRINT #2, USING "\\"; stupid$(code1);
IF addmode = 2 THEN
 c2$ = HEX$(code2 * 256 + code1)
 WHILE LEN(c2$) < 4: c2$ = "0" + c2$: WEND
 PRINT #2, USING "\  \"; c2$;
END IF
RETURN

dorel: PRINT #2, "$"; : IF code1 >= 128 THEN code1 = code1 - 256
code1 = pc + code1: IF addmode = 1 THEN PRINT #2, USING "\   \"; HEX$(code1);

LOCATE 10, 11
xr = (xr + 1) AND 3
PRINT MID$("/-\|", xr + 1, 1)
RETURN

handler:
'PRINT ERR;
LOCATE 10, 11
PRINT "Done!"
END






DATA "BRK",0,"JSR *",2,"RTI",0,"RTS",0,"???",0,"LDY #*",1,"CPY #*",1
DATA "CPX #*",1,"ORA (*,X)",1,"AND (*,X)",1,"EOR (*,X)",1,"ADC (*,X)",1
DATA "STA (*,X)",1,"LDA (*,X)",1,"CMP (*,X)",1,"SBC (*,X)",1,"???",0,"???",0
DATA "???",0,"???",0,"???",0,"LDX #*",1,"???",0,"???",0,"???",0,"???",0
DATA "???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"BIT *",1,"???"
DATA 0,"???",0,"STY *",1,"LDY *",1,"CPY *",1,"CPX *",1,"ORA *",1,"AND *",1
DATA "EOR *",1,"ADC *",1,"STA *",1,"LDA *",1,"CMP *",1,"SBC *",1,"ASL *",1
DATA "ROL *",1,"LSR *",1,"ROR *",1,"STX *",1,"LDX *",1,"DEC *",1,"INC *",1
DATA "???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"PHP",0
DATA "PLP",0,"PHA",0,"PLA",0,"DEY",0,"TAY",0,"INY",0,"INX",0,"ORA #*",1
DATA "AND #*",1,"EOR #*",1,"ADC #*",1,"???",0,"LDA #*",1,"CMP #*",1,"SBC #*"
DATA 1,"ASL A",0,"ROL A",0,"LSR A",0,"ROR A",0,"TXA",0,"TAX",0,"DEX",0,"NOP",0,"???"
DATA 0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0
DATA "BIT *",2,"JMP *",2,"JMP (*)",2,"STY *",2,"LDY *",2,"CPY *",2,"CPX *",2
DATA "ORA *",2,"AND *",2,"EOR *",2,"ADC *",2,"STA *",2,"LDA *",2,"CMP *",2
DATA "SBC *",2,"ASL *",2,"ROL *",2,"LSR *",2,"ROR *",2,"STX *",2,"LDX *",2
DATA "DEC *",2,"INC *",2,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0
DATA "???",0,"???",0,"BPL &",1,"BMI &",1,"BVC &",1,"BVS &",1,"BCC &",1
DATA "BCS &",1,"BNE &",1,"BEQ &",1,"ORA (*),Y",1,"AND (*),Y",1,"EOR (*),Y",1
DATA "ADC (*),Y",1,"STA (*),Y",1,"LDA (*),Y",1,"CMP (*),Y",1,"SBC (*),Y",1
DATA "???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0
DATA "???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0
DATA "???",0,"???",0,"STY *,X",1,"LDY *,X",1,"???",0,"???",0,"ORA *,X",1
DATA "AND *,X",1,"EOR *,X",1,"ADC *,X",1,"STA *,X",1,"LDA *,X",1,"CMP *,X",1
DATA "SBC *,X",1,"ASL *,X",1,"ROL *,X",1,"LSR *,X",1,"ROR *,X",1,"STX *,Y",1
DATA "LDX *,Y",1,"DEC *,X",1,"INC *,X",1,"???",0,"???",0,"???",0,"???",0
DATA "???",0,"???",0,"???",0,"???",0,"CLC",0,"SEC",0,"CLI",0,"SEI",0,"TYA",0
DATA "CLV",0,"CLD",0,"SED",0,"ORA *,Y",2,"AND *,Y",2,"EOR *,Y",2,"ADC *,Y",2
DATA "STA *,Y",2,"LDA *,Y",2,"CMP *,Y",2,"SBC *,Y",2,"???",0,"???",0,"???",0
DATA "???",0,"TXS",0,"TSX",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0
DATA "???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0
DATA "LDY *,X",2,"???",0,"???",0,"ORA *,X",2,"AND *,X",2,"EOR *,X",2
DATA "ADC *,X",2,"STA *,X",2,"LDA *,X",2,"CMP *,X",2,"SBC *,X",2,"ASL *,X",2
DATA "ROL *,X",2,"LSR *,X",2,"ROR *,X",2,"???",0,"LDX *,Y",2,"DEC *,X",2
DATA "INC *,X",2,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0,"???",0
DATA "???",0

FUNCTION fromhex (inhey$)

fhex2 = 0

FOR a9 = 1 TO LEN(inhey$)
a8$ = MID$(inhey$, a9, 1)
fhex2 = fhex2 * 16
IF (a8$ >= "0") AND (a8$ <= "9") THEN fhex2 = fhex2 + (ASC(a8$) - ASC("0"))
IF (a8$ >= "a") AND (a8$ <= "f") THEN fhex2 = fhex2 + (ASC(a8$) - ASC("a") + 10)
IF (a8$ >= "A") AND (a8$ <= "F") THEN fhex2 = fhex2 + (ASC(a8$) - ASC("A") + 10)
NEXT

fromhex = fhex2

END FUNCTION

